-- script to install a jar file and create Derby stored procedures  

-- 1) CD to your Derby installation bin directory such as

--    cd C:\Tools\Derby\bin

-- and then type ij at command prompt.


-- 2) Load the script under the ij command prompt.

--   ij> run 'jpatest_stored_procedure_create.sql';



CONNECT 'jdbc:derby:jpatest;create=false;user=jpatest;password=jpatest';
AUTOCOMMIT OFF;


-- install jar file that contains the stored procedures
CALL SQLJ.INSTALL_JAR('C:\Projects\jpaApp\jpaAppCommon\target\jpaAppCommon-1.0.jar', 'jpatest.jarForSP', 0);


-- replace a jar file
--CALL sqlj.replace_jar('C:\Projects\jpaApp\jpaAppCommon\target\jpaAppCommon-1.0.jar', 'jpatest.jarForSP');

-- set class path to find the installed jars
CALL SYSCS_UTIL.SYSCS_SET_DATABASE_PROPERTY('derby.database.classpath', 'jpatest.jarForSP');


CREATE PROCEDURE GET_AVG_PRICE(IN custID INTEGER, 
INOUT avgPrice DECIMAL(10,2), OUT custName VARCHAR(16)) 
PARAMETER STYLE JAVA READS SQL DATA LANGUAGE JAVA DYNAMIC RESULT SETS 0 
EXTERNAL NAME 'jpatest.util.StoredProcedures.spAvgPriceName';

CREATE PROCEDURE GET_CUSTOMER_ORDER(IN custID INTEGER,
INOUT avgPrice DECIMAL(10,2))
PARAMETER STYLE JAVA READS SQL DATA LANGUAGE JAVA DYNAMIC RESULT SETS 1
EXTERNAL NAME 'jpatest.util.StoredProcedures.spCustomerAndPrice';

CREATE PROCEDURE UPDATE_CUSTOMER(IN custID INTEGER,
IN custName VARCHAR(16), OUT sumPrice FLOAT)
PARAMETER STYLE JAVA LANGUAGE JAVA DYNAMIC RESULT SETS 0
EXTERNAL NAME 'jpatest.util.StoredProcedures.spUpdateCustomer';


COMMIT;
 
