package jpatest.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.TableGenerator;

@Entity
@Table (name="PHONE")
public class Phone extends BaseEntity {
	@Id
	@TableGenerator(name = "PHONE_SEQ_GEN", table = "SEQUENCE_GENERATOR_TB", pkColumnName = "SEQUENCE_NAME", valueColumnName = "SEQUENCE_VALUE", pkColumnValue = "PHONE_SEQ")
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "PHONE_SEQ_GEN")
	@Column(name = "PHONE_ID_PK")
	protected int phoneId;
	
	@Column(name = "PHONE_TYPE", insertable=false, updatable=false)
	protected String type;
	
	@Column(name = "PHONE_NUMBER")
	protected String number;

	@ManyToOne
	@JoinColumn(name="CUSTOMER_ID_FK", referencedColumnName="CUSTOMER_ID_PK")
	protected Customer customer;
	
	private static final long serialVersionUID = 1L;
	
	public Phone() {
		super();
	}
	
	public int getPhoneId() {   // no setter, since PK cannot be changed.
		return phoneId;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getNumber() {
		return number;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}
}
